//-       (1)/(2)--------
int ev(int e, int i, int j,
       int p1, int p2, int p3, int p4, int p5)
                           //  -    
                           // i -  
                           // j -   
{
//-1- -------------------------------------
      //--Open---------------
      double opj=NormalizeDouble(Open[j],Digits);
      double op0=NormalizeDouble(Open[i],Digits);
      double op1=NormalizeDouble(Open[i+1],Digits);
      double op2=NormalizeDouble(Open[i+2],Digits);
      double op3=NormalizeDouble(Open[i+3],Digits);
      double op4=NormalizeDouble(Open[i+4],Digits);
      //--Close--------------
      double clj=NormalizeDouble(Close[j],Digits);
      double cl0=NormalizeDouble(Close[i],Digits);
      double cl1=NormalizeDouble(Close[i+1],Digits);
      double cl2=NormalizeDouble(Close[i+2],Digits);
      double cl3=NormalizeDouble(Close[i+3],Digits);
      double cl4=NormalizeDouble(Close[i+4],Digits);
      //--High--------------
      double hj=NormalizeDouble(High[j],Digits);
      double h0=NormalizeDouble(High[i],Digits);
      double h1=NormalizeDouble(High[i+1],Digits);
      double h2=NormalizeDouble(High[i+2],Digits);
      double h3=NormalizeDouble(High[i+3],Digits);
      double h4=NormalizeDouble(High[i+4],Digits);
      //--Low--------------
      double lj=NormalizeDouble(Low[j],Digits);
      double l0=NormalizeDouble(Low[i],Digits);
      double l1=NormalizeDouble(Low[i+1],Digits);
      double l2=NormalizeDouble(Low[i+2],Digits);
      double l3=NormalizeDouble(Low[i+3],Digits);
      double l4=NormalizeDouble(Low[i+4],Digits);
      //--Max--------------
      int per=p2;
      int max=0;
      if(i+per<Bars) max=ArrayMaximum(High,per,i+1);
      //--Min--------------
      int min=0;
      if(i+per<Bars) min=ArrayMinimum(Low,per,i+1);
      //--cl1>op1----------------------------
      if(e==10011 && cl1>op1) return(10011);
      if(e==10012 && cl1<op1) return(10012);
      //--cl1>cl2--------------------------
      if(e==10021 && cl1>cl2) return(10021);
      if(e==10022 && cl1<cl2) return(10022);
      //--cl1>op2--------------------------
      if(e==10031 && cl1>op2) return(10031);
      if(e==10032 && cl1<op2) return(10032);
      //--min/max---------------------------
      if(e==10041 && i+1==min) return(10041);
      if(e==10042 && i+1==max) return(10042);
      //--cl1>op1----------------------------
      if(e==10051 && cl1>op1) return(10051);
      if(e==10052 && cl1<op1) return(10052);
      //-- -----------------------
      double g=p1;
      double prdiv=2/(2+g/10);
      double upgr=NormalizeDouble((l1+prdiv*(h1-l1)),Digits);
      double dogr=NormalizeDouble((h1-prdiv*(h1-l1)),Digits);
      if(e==10051 && cl1>upgr && op1>upgr) return(10051);
      if(e==10052 && l1<(lj-2*(hj-lj)))    return(10052);
      //-- -----------------------
      if(e==10053 && cl1<dogr && op1<dogr) return(10053);
      if(e==10054 && h1>(hj+2*(hj-lj)))    return(10054);
//-2- MA----------------------------------------------
      double ma11=iMA(NULL,0,p1,0,MODE_SMA,PRICE_MEDIAN,i+1);
      double ma12=iMA(NULL,0,p1,0,MODE_SMA,PRICE_MEDIAN,i+2);
      double ma13=iMA(NULL,0,p1,0,MODE_SMA,PRICE_MEDIAN,i+3);
      double ma21=iMA(NULL,0,p2,0,MODE_SMA,PRICE_MEDIAN,i+1);
      double ma22=iMA(NULL,0,p2,0,MODE_SMA,PRICE_MEDIAN,i+2);
      double ma31=iMA(NULL,0,p3,0,MODE_SMA,PRICE_MEDIAN,i+1);
      double ma32=iMA(NULL,0,p3,0,MODE_SMA,PRICE_MEDIAN,i+2);
      //-- MA-------------------------------------------
      if(e==10211 && ma12<ma22 && ma11>ma21) return(10211); //
      if(e==10212 && ma12>ma22 && ma11<ma21) return(10212); //
      //-- MA-----------------------------------------
      if(e==10221 && cl2<ma12 && cl1>ma11) return(10221); //
      if(e==10222 && cl2>ma12 && cl1<ma11) return(10222); //
      //--  MA-------------------------------------
      if(e==10231 && ma12<=ma13 && ma11>ma12) return(10231); //
      if(e==10232 && ma12>=ma13 && ma11<ma12) return(10232); //
//-- OsMA---------------------------------------
      double osmam1=iOsMA(NULL, 0,p1,p2,p3,PRICE_MEDIAN, i+1);
      double osmam2=iOsMA(NULL, 0,p1,p2,p3,PRICE_MEDIAN, i+2);
      double osmam3=iOsMA(NULL, 0,p1,p2,p3,PRICE_MEDIAN, i+3);
      double osmam4=iOsMA(NULL, 0,p1,p2,p3,PRICE_MEDIAN, i+4);
      double osmac1=iOsMA(NULL, 0,12,26,9,PRICE_CLOSE, i+1);
      double osmac2=iOsMA(NULL, 0,12,26,9,PRICE_CLOSE, i+2);
      double osmac3=iOsMA(NULL, 0,12,26,9,PRICE_CLOSE, i+3);
      double osmac4=iOsMA(NULL, 0,12,26,9,PRICE_CLOSE, i+4);
      //   OsMA PRICE_MEDIAN
      if(e==10311 && osmam1>osmam2 && osmam2<=osmam3) return(10311); //  
      if(e==10312 && osmam1<osmam2 && osmam2>=osmam3) return(10312); //  
      //   OsMA RICE_MEDIAN  
      if(e==10331 && osmam1>osmam2 && osmam2>osmam3 && osmam3<osmam4) return(10331); //  
      if(e==10332 && osmam1<osmam2 && osmam2<osmam3 && osmam3>osmam4) return(10332); //  
      //   OsMA PRICE_CLOSE
      if(e==10321 && osmac1>osmac2 && osmac2<=osmac3) return(10321); //  
      if(e==10322 && osmac1<osmac2 && osmac2>=osmac3) return(10322); //  
      //   OsMA RICE_MEDIAN
      if(e==10341 && osmam1>0 && osmam2<0) return(10341); // >0
      if(e==10342 && osmam1<0 && osmam2>0) return(10342); // <0
//--- RSI---------------------------------------
      double rsi11=iRSI(NULL, 0,p1,PRICE_MEDIAN, i+1);
      double rsi12=iRSI(NULL, 0,p1,PRICE_MEDIAN, i+2);
      double rsi21=iRSI(NULL, 0,p2,PRICE_MEDIAN, i+1);
      if(e==10411 && rsi12<42 && rsi11>42) return (10411);
      if(e==10412 && rsi12>58 && rsi11<58) return (10412);
//--- AC---------------------------------------
      double ac1=iAC(NULL, 0, i+1);
      double ac2=iAC(NULL, 0, i+2);
      double ac3=iAC(NULL, 0, i+3);
      double ac4=iAC(NULL, 0, i+4);
      //   AC
      if(e==10511 && ac1>ac2 && ac2<=ac3) return(10511); //  
      if(e==10512 && ac1<ac2 && ac2>=ac3) return(10512); //  
//-4-  (  - -------
      //    ,    
      if(e==10611 && j==-1)             return(10611); // in
      if(e==10612 && j!=-1 && j-i==990) return(10612); // in
      //Print("variables calc");
}
//-  ----------------------------------------------
int IsEventUp(int event, int i, int j,
              int p1, int p2, int p3, int p4, int p5)
                           // ,   -
                           // -    ind
   {
//--- -------------------------
      if(event==101) // in: min/max 20
      {
         if(ev(10041,i,j,
               p1, p2, p3, p4, p5)==10041) return(1); // in
         if(ev(10042,i,j,
               p1, p2, p3, p4, p5)==10042) return(2); // out
      }
      if(event==102) // hummer, stone
      {
         if(ev(10051,i,j,
               p1, p2, p3, p4, p5)==10051) return(1); // in
         if(ev(10052,i,j,
               p1, p2, p3, p4, p5)==10052) return(2); // out
      }
      if(event==103) // hummer, stone + min/max
      {
         if(ev(10051,i,j,
               p1, p2, p3, p4, p5)==10051
         && ev(10041,i,j,
               p1, p2, p3, p4, p5)==10041)
               {
               //Print(" 103 ");
               return(1); // in
               }
         if(ev(10052,i,j,
               p1, p2, p3, p4, p5)==10052
         || ev(10612,i,j,
               p1, p2, p3, p4, p5)==10612) return(2); // out
      }
//--- MA----------------------------
      //---  MA---------------------------------------
      if(event==201) // in, out: cross MA
      {
         if(ev(10211,i,j,
               p1, p2, p3, p4, p5)==10211) return(1); //  
         if(ev(10212,i,j,
               p1, p2, p3, p4, p5)==10212) return(2); //  
      }
      //--- MA   -----------------------------
      if(event==202) // in, out: cross MA
      {
         if(ev(10221,i,j,
               p1, p2, p3, p4, p5)==10221) return(1); //  
         if(ev(10222,i,j,
               p1, p2, p3, p4, p5)==10222) return(2); //  
      }
      //---  MA---------------------------
      if(event==203) // in, out: cross MA
      {
         if(ev(10231,i,j,
               p1, p2, p3, p4, p5)==10231) return(1); //  
         if(ev(10232,i,j,
               p1, p2, p3, p4, p5)==10232) return(2); //  
      }
//---  ----------------------------
      //---  OsMA---------------------------------------
      if(event==301) // in, out: 1 OsMA PM
      {
         if(ev(10311,i,j,
               p1, p2, p3, p4, p5)==10311) return(1); //  
         if(ev(10312,i,j,
               p1, p2, p3, p4, p5)==10312) return(2); //  
      }
      if(event==302) // in, out: 1 OsMA PC
      {
         if(ev(10321,i,j,
               p1, p2, p3, p4, p5)==10321) return(1); //  
         if(ev(10322,i,j,
               p1, p2, p3, p4, p5)==10322) return(2); //  
      }
      if(event==303) // in: 2 OsMA
      {
         if(ev(10331,i,j,
               p1, p2, p3, p4, p5)==10331) return(1); //  
         if(ev(10332,i,j,
               p1, p2, p3, p4, p5)==10332) return(2); //  
      }
      if(event==304) // in: 1 OsMA PM + cl1>cl2, out: 1 OsMA PM
      {
         if(ev(10311,i,j,
               p1, p2, p3, p4, p5)==10311
         && ev(10021,i,j,
               p1, p2, p3, p4, p5)==10021) return(1); //  
         if(ev(10312,i,j,
               p1, p2, p3, p4, p5)==10312) return(2); //  
      }
      if(event==305) // in: 1 OsMA PM + cl1>op1, out: 1 OsMA PM
      {
         if(ev(10311,i,j,
               p1, p2, p3, p4, p5)==10311
         && ev(10011,i,j,
               p1, p2, p3, p4, p5)==10011) return(1); //  
         if(ev(10312,i,j,
               p1, p2, p3, p4, p5)==10312) return(2); //  
      }
      if(event==306) // in: 1 OsMA PM + Cl1>Op2, out: 1 OsMA
      {
         if(ev(10311,i,j,
               p1, p2, p3, p4, p5)==10311
         && ev(10031,i,j,
               p1, p2, p3, p4, p5)==10031) return(1); //  
         if(ev(10312,i,j,
               p1, p2, p3, p4, p5)==10312) return(2); //  
      }
      if(event==307) // in: 1 OsMA PM + cl1>op1, out: 1 OsMA PM + cl1<op1
      {
         if(ev(10311,i,j,
               p1, p2, p3, p4, p5)==10311
         && ev(10011,i,j,
               p1, p2, p3, p4, p5)==10011) return(1); //  
         if(ev(10312,i,j,
               p1, p2, p3, p4, p5)==10312
         && ev(10012,i,j,
               p1, p2, p3, p4, p5)==10012) return(2); //  
      }
      if(event==308) // in, out: 1 OsMA PM x0
      {
         if(ev(10341,i,j,
               p1, p2, p3, p4, p5)==10341) return(1); //  
         if(ev(10342,i,j,
               p1, p2, p3, p4, p5)==10342) return(2); //  
      }
      //---  AC--------------------
      if(event==309) // in: 1 AC, out: 1 AC
      {
         if(ev(10511,i,j,
               p1, p2, p3, p4, p5)==10511) return(1); //  
         if(ev(10512,i,j,
               p1, p2, p3, p4, p5)==10512) return(2); //  
      }
      //---  RSI--------------------
      if(event==410) //
      {
         if(ev(10411,i,j,
               p1, p2, p3, p4, p5)==10411) return(1); //  
         if(ev(10412,i,j,
               p1, p2, p3, p4, p5)==10412) return(2); //  
      }
//--- -------------------------
      if(event==601) // in: 1 AC, out: 1 AC
      {
         if(ev(10611,i,j,
               p1, p2, p3, p4, p5)==10611) return(1); // in
         if(ev(10612,i,j,
               p1, p2, p3, p4, p5)==10612) return(2); // out
      }
   }
//-  ----------------------------------------------
int IsEventDo(int event, int i, int j,
              int p1, int p2, int p3, int p4, int p5)
                     // ,   -
                     // -    ind
   {
//--- -------------------------
      if(event==101) // in/out: min/max
      {
         if(ev(10042,i,j,
               p1, p2, p3, p4, p5)==10042) return(1); // in
         if(ev(10041,i,j,
               p1, p2, p3, p4, p5)==10041) return(2); // out
      }
      if(event==102) // hummer, stone
      {
         if(ev(10053,i,j,
               p1, p2, p3, p4, p5)==10053) return(1); // in
         if(ev(10054,i,j,
               p1, p2, p3, p4, p5)==10054) return(2); // out
      }
      if(event==103) // hummer, stone + max/min
      {
         if(ev(10053,i,j,
               p1, p2, p3, p4, p5)==10053
         && ev(10042,i,j,
               p1, p2, p3, p4, p5)==10042) return(1); // in
         if(ev(10054,i,j,
               p1, p2, p3, p4, p5)==10054
         || ev(10612,i,j,
               p1, p2, p3, p4, p5)==10612) return(2); // out
      }
//---  MA----------------------------
      //--- MA---------------------------------------
      if(event==201) // in: coss MA
      {
         if(ev(10212,i,j,
               p1, p2, p3, p4, p5)==10212) return(1); //  
         if(ev(10211,i,j,
               p1, p2, p3, p4, p5)==10211) return(2); //  
      }
      //--- MA   -----------------------------
      if(event==202) // in, out: cross MA
      {
         if(ev(10222,i,j,
               p1, p2, p3, p4, p5)==10222) return(1); //  
         if(ev(10221,i,j,
               p1, p2, p3, p4, p5)==10221) return(2); //  
      }
      //---  MA----------------------------
      if(event==203) // in, out: cross MA
      {
         if(ev(10232,i,j,
               p1, p2, p3, p4, p5)==10232) return(1); //  
         if(ev(10231,i,j,
               p1, p2, p3, p4, p5)==10231) return(2); //  
      }
//---  ----------------------------
      //--- OsMA---------------------------------------
      if(event==301) // in: 1 OsMA PM, out: 1 OsMA PM
      {
         if(ev(10312,i,j,
               p1, p2, p3, p4, p5)==10312) return(1); //  
         if(ev(10311,i,j,
               p1, p2, p3, p4, p5)==10311) return(2); //  
      }
      if(event==302) // in: 1 OsMA PC, out: 1 OsMA PC
      {
         if(ev(10322,i,j,
               p1, p2, p3, p4, p5)==10322) return(1); //  
         if(ev(10321,i,j,
               p1, p2, p3, p4, p5)==10321) return(2); //  
      }
      if(event==303) // in: 2 OsMA PM, out: 2 OsMA PM
      {
         if(ev(10332,i,j,
               p1, p2, p3, p4, p5)==10332) return(1); //  
         if(ev(10331,i,j,
               p1, p2, p3, p4, p5)==10331) return(2); //  
      }
      if(event==304) // in: 1 OsMA PM + cl1<cl2, out: 1 OsMA PM
      {
         if(ev(10312,i,j,
               p1, p2, p3, p4, p5)==10312
         && ev(10022,i,j,
               p1, p2, p3, p4, p5)==10022) return(1); //  
         if(ev(10311,i,j,
               p1, p2, p3, p4, p5)==10311) return(2); //  
      }
      if(event==305) // in: 1 OsMA PM + cl1<op1, out: 1 OsMA PM
      {
         if(ev(10312,i,j,
               p1, p2, p3, p4, p5)==10312
         && ev(10012,i,j,
               p1, p2, p3, p4, p5)==10012) return(1); //  
         if(ev(10311,i,j,
               p1, p2, p3, p4, p5)==10311) return(2); //  
      }
      if(event==306) // in: 1 OsMA PM + Cl1<Op2, out: 1 OsMA
      {
         if(ev(10312,i,j,
               p1, p2, p3, p4, p5)==10312
         && ev(10032,i,j,
               p1, p2, p3, p4, p5)==10032) return(1); //  
         if(ev(10311,i,j,
               p1, p2, p3, p4, p5)==10311) return(2); //  
      }
      if(event==307) // in: 1 OsMA PM + cl1>op1, out: 1 OsMA PM + cl1<op1
      {
         if(ev(10312,i,j,
               p1, p2, p3, p4, p5)==10312
         && ev(10012,i,j,
               p1, p2, p3, p4, p5)==10012) return(1); //  
         if(ev(10311,i,j,
               p1, p2, p3, p4, p5)==10311
         && ev(10011,i,j,
               p1, p2, p3, p4, p5)==10011) return(2); //  
      }
      if(event==308) // in, out: 1 OsMA PM x0
      {
         if(ev(10342,i,j,
               p1, p2, p3, p4, p5)==10342) return(1); //  
         if(ev(10341,i,j,
               p1, p2, p3, p4, p5)==10341) return(2); //  
      }
      //--- AC---------------------------------------
      if(event==309) //   AC
      {
         if(ev(10512,i,j,
               p1, p2, p3, p4, p5)==10512) return(1); //  
         if(ev(10511,i,j,
               p1, p2, p3, p4, p5)==10511) return(2); //  
      }
      //---  RSI--------------------
      if(event==410) //
      {
         if(ev(10412,i,j,
               p1, p2, p3, p4, p5)==10412) return(1); //  
         if(ev(10411,i,j,
               p1, p2, p3, p4, p5)==10411) return(2); //  
      }
//--- -------------------------
      if(event==601) // in: 1 AC, out: 1 AC
      {
         if(ev(10611,i,j,
               p1, p2, p3, p4, p5)==10611) return(1); // in
         if(ev(10612,i,j,
               p1, p2, p3, p4, p5)==10612) return(2); // out
      }
   }